" Vim syntax file
" Language:	RESOLVE/C++
" Maintainer:	Keith Lazuka <lazuka.1@osu.edu>
" Last Change:	April 15, 2004

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

" Read the C++ syntax to start with (which is based off c.vim)
if version < 600
  so <sfile>:p:h/cpp.vim
else
  runtime! syntax/cpp.vim
  unlet b:current_syntax
endif

" RESOLVE/C++ extensions
syn keyword rcppOperations	global_function global_procedure function_body procedure_body
syn keyword rcppOperations	is_abstract procedure function
syn keyword rcppParameterModes	preserves produces alters consumes
syn keyword rcppType		Real Integer Boolean Character Text
syn keyword rcppType		Character_IStream Character_OStream
syn keyword rcppBoolean		true false
syn keyword rcppRelationships	checks extends implements
syn keyword rcppKeywords	object and or not mod enumeration self
syn keyword rcppView		abstract_instance abstract_template 
syn keyword rcppView		concrete_instance concrete_template
syn region rcppFormalComment	start=%/\*!% end=%!\*/%

" Default highlighting
if version >= 508 || !exists("did_rcpp_syntax_inits")
  if version < 508
    let did_rcpp_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink rcppOperations		Function
  HiLink rcppParameterModes	Statement
  HiLink rcppKeywords		Statement
  HiLink rcppType		Type
  HiLink rcppBoolean		Boolean
  HiLink rcppFormalComment	Special	
  HiLink rcppRelationships	Special
  HiLink rcppView		Special
  delcommand HiLink
endif

let b:current_syntax = "rcpp"

" vim: ts=8
